package com.zj365.dc.fragment

import android.app.Activity.RESULT_OK
import android.content.Intent
import android.graphics.Typeface
import android.graphics.drawable.Drawable
import android.graphics.drawable.GradientDrawable
import android.os.Build
import android.provider.Settings
import android.text.TextUtils
import android.view.View
import android.view.ViewGroup
import androidx.core.content.ContextCompat
import androidx.lifecycle.MutableLiveData
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import cn.jpush.android.api.JPushInterface
import com.shuyu.gsyvideoplayer.listener.VideoAllCallBack
import com.tamsiree.rxkit.RxTimeTool
import com.xty.base.fragment.BaseVmFrag
import com.xty.base.utils.UserInfoDefin
import com.xty.common.Const
import com.xty.common.LogUtils
import com.xty.common.MMkvHelper
import com.xty.common.UmengEventId
import com.xty.common.app.MyApp
import com.xty.common.arouter.ARouterUrl
import com.xty.common.arouter.RouteManager
import com.xty.common.bracelet.YCBBlueConnectHelper
import com.xty.common.bracelet.YCBManager
import com.xty.common.bracelet.YCBOrder
import com.xty.common.bracelet.checkBlueConnectPermission
import com.xty.common.bracelet.getBluePermission
import com.xty.common.bracelet.isGpsOpen
import com.xty.common.event.AgainSignEvent
import com.xty.common.event.BlueToothConnectEvent
import com.xty.common.event.FamilyEvent
import com.xty.common.event.Health24HourStatusEvent
import com.xty.common.event.MyInfoEvent
import com.xty.common.event.WorkManagerEvent
import com.xty.common.event.XTangOpenEvent
import com.xty.common.event.XTangUpdateEvent
import com.xty.common.marqueen.SimpleMF
import com.xty.common.onEventObject
import com.xty.common.setImageUser
import com.xty.common.util.CommonToastUtils
import com.xty.common.util.CommonUtils
import com.xty.common.work.MyWorkManger
import com.zj365.mime.weight.NoticeSettingDialog
import com.xty.network.MyRetrofit
import com.xty.network.model.BannerBean
import com.xty.network.model.FamilyBean
import com.xty.network.model.MainBean
import com.xty.network.model.MessageBean
import com.xty.network.model.ReportBean
import com.xty.network.model.ScienceBean
import com.xty.network.model.XTangInfoBean
import com.youth.banner.indicator.RoundLinesIndicator
import com.youth.banner.listener.OnPageChangeListener
import com.zj365.dc.BuildConfig
import com.zj365.dc.R
import com.zj365.dc.activity.MainActivity
import com.zj365.dc.adapter.BannerCustomAdapter
import com.zj365.dc.adapter.FamilyAdapter
import com.zj365.dc.adapter.ScienceAdapter
import com.zj365.dc.adapter.holder.VideoHolder
import com.zj365.dc.databinding.FragHealthBinding
import com.zj365.dc.vm.HealthVm
import com.zj365.dc.weight.AgainSignDialog
import com.zj365.health.weight.DialogTip
import kotlinx.coroutines.Dispatchers
import kotlinx.coroutines.Job
import kotlinx.coroutines.delay
import kotlinx.coroutines.launch
import org.greenrobot.eventbus.Subscribe
import org.greenrobot.eventbus.ThreadMode
import org.json.JSONArray
import org.json.JSONObject
import java.text.SimpleDateFormat
import java.util.regex.Matcher
import java.util.regex.Pattern
import kotlin.math.max
import kotlin.math.min

/**
 * 健康*/


class
HealthHomeFrag : BaseVmFrag<HealthVm>() {

    val binding by lazy { FragHealthBinding.inflate(layoutInflater) }

    //重签名
    private val signDialog by lazy {
        AgainSignDialog(requireContext(), {
            RouteManager.goAct(ARouterUrl.LOGIN_ACT)
            requireActivity().finish()
        }) {
            RouteManager.goAct(ARouterUrl.AGAIN_SIGN)
        }
    }
    private var canGoto24Healthresult: Boolean = true
    private var isDemonstrate: Boolean = false

    //家人列表适配器
    private val mFamilyAdapter by lazy { FamilyAdapter() }

    private val mBannerAdapter by lazy { BannerCustomAdapter(requireContext()) }
    private var showIdInfo = "" //需要显示的信息的id

    private var showFamily: FamilyBean? = null
    override fun setViewModel() = HealthVm()


    val adapterSince by lazy { ScienceAdapter() }

    private val getDeviceInfoLive by lazy { MutableLiveData<String>() }
    private var getDeviceInfoJob: Job? = null
    private var isRefresh = true

    private var reportBean: ReportBean? = null//24小时日报数据

    private val dialogBind by lazy {
        DialogTip(requireContext(), "需绑定安瑜健康手表，才能查看", "去绑定") {
            RouteManager.goAct(ARouterUrl.DEVICE_CHOICE)
        }
    }
    private val dialogInfoUn by lazy {
        DialogTip(requireContext(), "请完善基本信息") {
            RouteManager.goAct(ARouterUrl.INFO_SIMPLE)
        }
    }
    override fun setLayout(): View = binding.root
    override fun initView() {
        super.initView()
        statusBar(binding.statusBar)

        initFamilyAdapter()
        request()
        refresh()

        binding.mBanner.addBannerLifecycleObserver(this)
            .setAdapter(mBannerAdapter)
            .setIndicator(RoundLinesIndicator(context))
            .setIndicatorSelectedWidth(dp2px(15))
            .addOnPageChangeListener(onPageChangeListener)

        mBannerAdapter.setOnBannerListener { data, position ->
            var bannerBean = data as BannerBean
            onEventObject(
                requireContext(),
                UmengEventId.Banner,
                "type:${bannerBean.bannerType}; 标题:${bannerBean.title}"
            )
            when (bannerBean.bannerType) {
                1 -> {//图片

                }

                5 -> { //内部跳转
                    bundle.clear()
                    bundle.putString("title", bannerBean.title)
                    bundle.putString("url", bannerBean.linkAddress)
                    RouteManager.goAct(ARouterUrl.WEB_ACT, bundle)
                }

                10 -> {//web 跳转
                    bundle.clear()
                    bundle.putString("title", bannerBean.title)
                    bundle.putString("url", bannerBean.linkAddress)
                    RouteManager.goAct(ARouterUrl.WEB_ACT, bundle)
                }
            }
        }
        setOnClickListener()
//        updateWarningStatus()
        initAdapter()
    }

    private fun initAdapter() {
        binding.mRecycleNews.layoutManager = LinearLayoutManager(requireContext())
        binding.mRecycleNews.adapter = adapterSince
        adapterSince.setOnItemClickListener { adapter, view, position ->
            bundle.clear()
            var bean = adapter.getItem(position) as ScienceBean
            bundle.putSerializable("bean", bean)
            onEventObject(requireContext(), UmengEventId.HealthScience, "${bean.name}")
            RouteManager.goAct(ARouterUrl.SCIENCE_DETAIL, bundle)

        }

    }


    private var onPageChangeListener = object : OnPageChangeListener {
        override fun onPageScrolled(
            position: Int,
            positionOffset: Float,
            positionOffsetPixels: Int
        ) {
        }

        override fun onPageSelected(position: Int) {
            var viewHolder = binding.mBanner.adapter.viewHolder
            if (viewHolder is VideoHolder) {
                var player = viewHolder.player
                player.setVideoAllCallBack(object : VideoAllCallBack {
                    override fun onStartPrepared(url: String?, vararg objects: Any?) {
                    }

                    override fun onPrepared(url: String?, vararg objects: Any?) {
                    }

                    override fun onClickStartIcon(url: String?, vararg objects: Any?) {
                        binding.mBanner.stop()
                        binding.mBanner.isAutoLoop(false)
                    }

                    override fun onClickStartError(url: String?, vararg objects: Any?) {
                    }

                    override fun onClickStop(url: String?, vararg objects: Any?) {
                    }

                    override fun onClickStopFullscreen(url: String?, vararg objects: Any?) {
                    }

                    override fun onClickResume(url: String?, vararg objects: Any?) {
                    }

                    override fun onClickResumeFullscreen(
                        url: String?,
                        vararg objects: Any?
                    ) {
                    }

                    override fun onClickSeekbar(url: String?, vararg objects: Any?) {
                    }

                    override fun onClickSeekbarFullscreen(
                        url: String?,
                        vararg objects: Any?
                    ) {
                    }

                    override fun onAutoComplete(url: String?, vararg objects: Any?) {
                        println("Test----------onAutoComplete url:$url;objects$objects")
                        binding.mBanner.isAutoLoop(true)
                        binding.mBanner.start()
                    }

                    override fun onEnterFullscreen(url: String?, vararg objects: Any?) {
                    }

                    override fun onQuitFullscreen(url: String?, vararg objects: Any?) {
                    }

                    override fun onQuitSmallWidget(url: String?, vararg objects: Any?) {
                    }

                    override fun onEnterSmallWidget(url: String?, vararg objects: Any?) {
                    }

                    override fun onTouchScreenSeekVolume(
                        url: String?,
                        vararg objects: Any?
                    ) {
                    }

                    override fun onTouchScreenSeekPosition(
                        url: String?,
                        vararg objects: Any?
                    ) {
                    }

                    override fun onTouchScreenSeekLight(
                        url: String?,
                        vararg objects: Any?
                    ) {
                    }

                    override fun onPlayError(url: String?, vararg objects: Any?) {
                    }

                    override fun onClickStartThumb(url: String?, vararg objects: Any?) {
                    }

                    override fun onClickBlank(url: String?, vararg objects: Any?) {
                    }

                    override fun onClickBlankFullscreen(
                        url: String?,
                        vararg objects: Any?
                    ) {
                    }

                })
            }
        }

        override fun onPageScrollStateChanged(state: Int) {
        }
    }

    private fun setOnClickListener() {
        binding.mChildView.llAiConfectioner.setOnClickListener(onClickListener)
        binding.mChildView.llAiSkinMeasurement.setOnClickListener(onClickListener)
        binding.mChildView.llCancerScreening.setOnClickListener(onClickListener)

        binding.mChildView.llMentalTest.setOnClickListener(onClickListener)
        binding.mChildView.llAiTongueDiagnosis.setOnClickListener(onClickListener)
        binding.mChildView.llDietManagement.setOnClickListener(onClickListener)

        /*//30天健康风险
        binding.tvHealthRisk.setOnClickListener(onClickListener)
        //健康风险评估
        binding.tvRiskCommit.setOnClickListener(onClickListener)
        //防癌筛查
        binding.tvCheckCancer.setOnClickListener(onClickListener)
        //舌诊
        binding.tvTongueDiagnosis.setOnClickListener(onClickListener)
        //手表
        binding.mChildHomeView.llWatch.setOnClickListener {

            if (Const.watchType == -1) {  //当前未绑定，并且选择的用户是自己
                if (showIdInfo == "") {
                    RouteManager.goAct(ARouterUrl.DEVICE_CHOICE)
                } else {
                    CommonToastUtils.showToast("家人已解绑手表，无法查看")
                }
            } else {
                bundle.clear()
                if (showIdInfo == "") {  //如果是自己，直接传自己的设备信息过去
                    CommonUtils.getMyUserInfo()?.let {
                        bundle.putSerializable("user", it)
                    }
                } else {  //其他用户传id过去查询设备信息
                    bundle.putSerializable("userId", showIdInfo)
                }
                RouteManager.goAct(ARouterUrl.DEV_INFO, bundle)
            }
        }*/

        binding.mCom.llHealthRecords.setOnClickListener(onClickListener)
        /*binding.mChildHomeView.mRelInterDk.setOnClickListener(onClickListener)
        binding.mChildHomeView.mRelInterBD.setOnClickListener(onClickListener)
        binding.mChildHomeView.mRelInterFamily.setOnClickListener(onClickListener)*/
        binding.mCom.llHealthCode.setOnClickListener(onClickListener)
        binding.mCom.llDailyBenefit.setOnClickListener(onClickListener)
        binding.mCom.llVideoInterview.setOnClickListener(onClickListener)
        /*binding.mOrganView.llCompare.setOnClickListener(onClickListener)
        binding.myManager.setOnClickListener(onClickListener)
        binding.myHealthDa.setOnClickListener(onClickListener)*/
    }


    private var onClickListener = View.OnClickListener {
        when (it.id) {
            R.id.ll_health_records -> {  //健康档案
                bundle.putString("id", showIdInfo)
                RouteManager.goAct(ARouterUrl.HEALTH_RECORD, bundle)
            }

           /* R.id.my_manager -> {  //我的管家
                CommonUtils.getMyUserId()?.let {
                    bundle.clear()
                    bundle.putString("fromUserId", it)
                    RouteManager.goAct(ARouterUrl.MY_KEEPER, bundle)
                }
            }

            R.id.ll_compare -> {//健康对比
                if (isDemonstrate) {
                    dialogBind.show()
                    return@OnClickListener
                }
                goComparePage()
            }

            //我的家人
            R.id.mRelInterFamily -> {
                onEventObject(requireContext(), UmengEventId.MyFamily, "首页")
                if (isBind()) {
                    RouteManager.goAct(ARouterUrl.FAMILY)
                } else {
                    CommonToastUtils.showToast(com.xty.common.R.string.please_bind_device)
                }
            }
            //榜单
            R.id.mRelInterBD -> {
                if (isDemonstrate) {
                    dialogBind.show()
                    return@OnClickListener
                }
                mViewModel.allData.value?.apply {
                    if (data.adorn.activeWear <= 3) {
                        CommonToastUtils.showToast("尊敬的用户您好，您正处于3天建模期，请坚持佩戴")
                        return@OnClickListener
                    }
                    onEventObject(requireContext(), UmengEventId.HealthRank)
                    bundle.clear()
                    bundle.putInt("status", data.adorn.health + 1)
                    bundle.putInt("type", 0)
                    RouteManager.goAct(ARouterUrl.RANK_LIST, bundle)
                }

            }
            //打卡
            R.id.mRelInterDk -> {
                CommonUtils.getMyUserInfo()?.apply {
                    onEventObject(requireContext(), UmengEventId.HealthDk)
                    bundle.clear()
                    bundle.putSerializable("user", this)
                    RouteManager.goAct(ARouterUrl.DK_ACT, bundle)
                }
            }
            //评估
            R.id.tv_risk_commit -> {
//                onEventObject(requireContext(), UmengEventId.HealthRisk)
                bundle.clear()
                bundle.putString("id", showIdInfo)
                RouteManager.goAct(ARouterUrl.SUBMIT_REPORTMain, bundle)
            }*/
            //防癌
            R.id.ll_cancer_screening -> {
//                onEventObject(requireContext(), UmengEventId.HealthRisk)
                bundle.clear()
                bundle.putString("id", showIdInfo)
                RouteManager.goAct(ARouterUrl.PRVENT_CANCER, bundle)
//                showToast("功能暂未开通，敬请期待")
            }
            //舌诊
            R.id.ll_ai_tongue_diagnosis -> {
                onEventObject(requireContext(), UmengEventId.HealthRisk)
                bundle.clear()
                bundle.putString("id", showIdInfo)
                RouteManager.goAct(ARouterUrl.TONGUE_MAIN_ACTIVITY, bundle)
//                showToast("功能暂未开通，敬请期待")
            }
           /* //问卷
            R.id.ivWarn2 -> {
                onEventObject(requireContext(), UmengEventId.HealthRisk)
                bundle.clear()
                bundle.putString("id", showIdInfo)
//                RouteManager.goAct(ARouterUrl.SUBMIT_REPORT, bundle)
                RouteManager.goAct(ARouterUrl.SUBMIT_REPORTMain, bundle)
            }
            //预警
            R.id.tv_health_risk -> {
                if (isDemonstrate) {
                    bundle.clear()
                    bundle.putString("id", showIdInfo)
                    bundle.putInt("page", 1)
                    RouteManager.goAct(ARouterUrl.WARRING, bundle)
                    return@OnClickListener
                }
                mViewModel.allData.value?.apply {
                    data.apply {
                        if (adorn.wearCount > 29 && adorn.activeWear > 14) {
                            onEventObject(requireContext(), UmengEventId.Health30Day)
                            bundle.clear()
                            bundle.putString("id", showIdInfo)
                            bundle.putInt("page", 1)
                            RouteManager.goAct(ARouterUrl.WARRING, bundle)
                        } else {
                            if (showIdInfo.isEmpty()) {
                                onEventObject(
                                    requireContext(),
                                    UmengEventId.Health30Day,
                                    "佩戴未满30天或活跃天数未满15天。"
                                )
                                CommonToastUtils.showToast("尊敬的用户您好，该功能需要佩戴30天且活跃佩戴15天查看，请坚持佩戴且每日同步数据！")
                            } else {
                                onEventObject(
                                    requireContext(),
                                    UmengEventId.Health30Day,
                                    "关联用户处于7天建模中！"
                                )
                                CommonToastUtils.showToast("您关联的用户正处于7天建模中……")
                            }
                        }
                    }
                }
            }
            //健康管家
            R.id.mGuide2 -> {
                if (isDemonstrate) {
                    dialogBind.show()
                    return@OnClickListener
                }
                if (showIdInfo.isNullOrEmpty()) {
                    if (isBind()) {
                        onEventObject(requireContext(), UmengEventId.HealthAdmin)
                        CommonUtils.getMyUserInfo()?.apply {
                            bundle.clear()
                            bundle.putString("fromUserId", id.toString())
                            RouteManager.goAct(ARouterUrl.HOUSE_KEEPER, bundle)
                        }

                    } else {
                        onEventObject(requireContext(), UmengEventId.HealthAdmin, "未绑定点击")
                        CommonToastUtils.showToast(com.xty.common.R.string.please_bind_device)
                    }
                } else {
                    onEventObject(requireContext(), UmengEventId.HealthAdmin, "关注家人点击")
                    CommonToastUtils.showToast("不支持上传家人健康信息")
                }
            }
            //健康方案
            R.id.mGuide_1 -> {
//                Const.mainLiveData.value?.apply {
//                    bundle.clear()
//                    bundle.putString("id", showIdInfo)
//                    RouteManager.goAct(ARouterUrl.HEALTH_PROP, bundle)
//                }
                if (isDemonstrate) {
                    dialogBind.show()
                    return@OnClickListener
                }
                onEventObject(requireContext(), UmengEventId.HealthProgrammes, "首页")
                RouteManager.goAct(ARouterUrl.MY_PROG)
            }

            R.id.mGuide_4 -> {
                RouteManager.goAct(ARouterUrl.DATA_MANAGE)
            }
            //绑定
            R.id.mBtnBind -> {
                RouteManager.goAct(ARouterUrl.DEVICE_CHOICE)
            }*/
        }
    }

    private fun goComparePage() {
        bundle.clear()
        bundle.putString("id", showIdInfo)
        RouteManager.goAct(ARouterUrl.COMPARE_PAGE_DATA_ACT, bundle)
    }

/**
     * 设置设备信息*/
    /*private fun setDeviceInfo(deviceInfo: DeviceInfoBean?) {
        if (null != deviceInfo) {
            if (blueTooth()) {
                binding.mCom.mWatchType.text = getString(R.string.blue_tooth)
                binding.mCom.mWatchType.visibility = View.VISIBLE
                val drawable = getDrawable(R.mipmap.ic_watch_bluetooth)
                drawable.setBounds(0, 0, drawable.minimumWidth, drawable.minimumHeight)
                binding.mCom.mWatchType.setCompoundDrawables(drawable, null, null, null)
            } else {
                binding.mCom.mWatchType.text = getString(R.string.lite_4g)
                binding.mCom.mWatchType.visibility = View.VISIBLE
                val drawable = getDrawable(R.mipmap.ic_watch_4g)
                drawable.setBounds(0, 0, drawable.minimumWidth, drawable.minimumHeight)
                binding.mCom.mWatchType.setCompoundDrawables(drawable, null, null, null)
            }
            binding.mCom.mBindState.visibility = View.VISIBLE

            if (deviceInfo.bindState) {//已绑定
                binding.mCom.mBindState.apply {
                    text = "已绑定"
                    background = null
                    val drawable = getDrawable(R.mipmap.ic_bangding)
                    drawable.setBounds(0, 0, drawable.minimumWidth, drawable.minimumHeight)
                    setCompoundDrawables(drawable, null, null, null)
                }
                binding.mCom.mWearManager.text = "佩戴管理"

                when (deviceInfo.connectState) {
                    YCBBlueConnectHelper.BLEConnectState.Connected -> {//已连接
                        binding.mCom.mConnectStatu.apply {
                            setBackgroundResource(R.drawable.shape_bind_bg_new_2)
                            text = deviceInfo.battery
                            setTextColor(resources.getColor(R.color.col_27B8, null))
                            var drawable: Drawable = getDrawable(R.mipmap.ic_battery)
                            if (!deviceInfo.battery.isNullOrEmpty()) {
                                val str =
                                    deviceInfo.battery.substring(2, deviceInfo.battery.length - 1)
                                val pattern: Pattern = Pattern.compile("[0-9]*")
                                val isNum: Matcher = pattern.matcher(str)
                                if (isNum.matches()) {
                                    val battery = str.toInt()
                                    drawable = if (battery > 20) {
                                        getDrawable(R.mipmap.ic_battery)
//                                    } else if (battery > 70) {
//                                        getDrawable(R.mipmap.ic_battery_90)
//                                    } else if (battery > 50) {
//                                        getDrawable(R.mipmap.ic_battery_70)
//                                    } else if (battery > 30) {
//                                        getDrawable(R.mipmap.ic_battery_50)
//                                    } else if (battery > 10) {
//                                        getDrawable(R.mipmap.ic_battery_30)
                                    } else {
                                        setTextColor(resources.getColor(R.color.col_2628, null))
                                        text =
                                            context.resources.getString(R.string.health_low_battery)
                                        setBackgroundResource(R.drawable.shape_bind_bg_new_1)
                                        getDrawable(R.mipmap.ic_diancbuz)
                                    }
                                }
                            }
                            drawable.setBounds(
                                0,
                                0,
                                drawable.minimumWidth,
                                drawable.minimumHeight
                            )
                            setCompoundDrawables(drawable, null, null, null)
                        }
                    }

                    YCBBlueConnectHelper.BLEConnectState.Connecting -> {//连接中
                        binding.mCom.mConnectStatu.apply {
                            text = "连接中..."
                            setCompoundDrawables(null, null, null, null)
                        }
                    }

                    YCBBlueConnectHelper.BLEConnectState.DisConnect -> {//未连接
                        binding.mCom.mConnectStatu.apply {
                            text = "未连接"
                            val drawable = getDrawable(R.mipmap.ic_not_connect)
                            drawable.setBounds(
                                0,
                                0,
                                drawable.minimumWidth,
                                drawable.minimumHeight
                            )
                            setCompoundDrawables(drawable, null, null, null)
                        }
                    }
                }
                binding.mChildHomeView.mRelInterBD.visibility = View.VISIBLE
                binding.mCom.mConnectStatu.visibility = View.VISIBLE
            } else {
                binding.mCom.mBindState.apply {
                    text = "未绑定"
                    val drawable = getDrawable(R.mipmap.ic_unbind)
                    drawable.setBounds(0, 0, drawable.minimumWidth, drawable.minimumHeight)
                    setCompoundDrawables(drawable, null, null, null)
                }
                binding.mCom.mWearManager.text = "绑定手表"

                binding.mChildHomeView.mRelInterBD.visibility = View.GONE
                binding.mCom.mConnectStatu.visibility = View.INVISIBLE
                binding.mCom.mWatchType.visibility = View.INVISIBLE

            }
        } else {
            binding.mCom.mWatchType.text = getString(R.string.blue_tooth)
            val drawable = getDrawable(R.mipmap.ic_watch_bluetooth)
            drawable.setBounds(0, 0, drawable.minimumWidth, drawable.minimumHeight)
            binding.mCom.mWatchType.visibility = View.VISIBLE
            binding.mCom.mWatchType.setCompoundDrawables(drawable, null, null, null)
            binding.mCom.mBindState.visibility = View.INVISIBLE
            binding.mCom.mConnectStatu.visibility = View.INVISIBLE
        }
    }*/

/**
     * 设置天气信息*/


    private fun setWeatherInfo(weather: MainBean.Weather?) {
//        if (null == weather) {
//            binding.mCom.tvLocationWeather.visibility = View.GONE
//        } else {
//            weather.apply {
//                if (city.isNullOrEmpty() || weatherNo.isNullOrEmpty()) {
//                    binding.mCom.tvLocationWeather.visibility = View.GONE
//                    return
//                }
//                binding.mCom.tvLocationWeather.text = "${city}  ${weatherInfo}"
//                var icon = when (weatherNo) {
//                    "32" -> {//晴天
//                        R.mipmap.weather_sunny
//                    }
//                    "44" -> {//多云
//                        R.mipmap.weather_cloudy
//                    }
//                    "20" -> {//阴天
//                        R.mipmap.weather_yin
//                    }
//                    "12" -> {//雨天
//                        R.mipmap.weather_rain
//                    }
//                    "45" -> {//雷阵雨
//                        R.mipmap.weather_thunder_shower
//                    }
//                    "16" -> {//雪
//                        R.mipmap.weather_snow
//                    }
//                    else -> {
//                        R.mipmap.weather_sunny
//                    }
//                }
//                val drawable = getDrawable(icon)
//                drawable!!.setBounds(0, 0, drawable.minimumWidth, drawable.minimumHeight)
//                binding.mCom.tvLocationWeather.setCompoundDrawables(null, null, drawable, null)
//                binding.mCom.tvLocationWeather.visibility = View.VISIBLE
//            }
//        }
    }

/**
     * 设置设备信息*/


  /*  private fun setBindDeviceInfo(deviceInfo: MainBean.DeviceTotal?) {
        deviceInfo?.let {
            if (it.sphygmomanometer > 0) {
                binding.mChildHomeView.tvXueyaNum.setTextColor(
                    ContextCompat.getColor(
                        requireContext(),
                        R.color.col_02c
                    )
                )
            } else {
                binding.mChildHomeView.tvXueyaNum.setTextColor(
                    ContextCompat.getColor(
                        requireContext(),
                        R.color.col_c7c
                    )
                )
            }
            binding.mChildHomeView.tvXueyaNum.text = "已绑定" + it.sphygmomanometer + "台"
            if (it.bloodGlucose > 0) {
                binding.mChildHomeView.tvXuetangNum.setTextColor(
                    ContextCompat.getColor(
                        requireContext(),
                        R.color.col_02c
                    )
                )
            } else {
                binding.mChildHomeView.tvXuetangNum.setTextColor(
                    ContextCompat.getColor(
                        requireContext(),
                        R.color.col_c7c
                    )
                )
            }
            binding.mChildHomeView.tvXuetangNum.text = "已绑定" + it.bloodGlucose + "台"
            if (it.bodyFatScale > 0) {
                binding.mChildHomeView.tvBodyFatNum.setTextColor(
                    ContextCompat.getColor(
                        requireContext(),
                        R.color.col_02c
                    )
                )
            } else {
                binding.mChildHomeView.tvBodyFatNum.setTextColor(
                    ContextCompat.getColor(
                        requireContext(),
                        R.color.col_c7c
                    )
                )
            }
            binding.mChildHomeView.tvBodyFatNum.text = "已绑定${it.bodyFatScale}台"
        }
        binding.mChildHomeView.llXueya.setOnClickListener {
            //已绑定血压列表
            bundle.clear()
            bundle.putString("userId", showIdInfo)
            RouteManager.goAct(ARouterUrl.XUEYAJI_BIND_LIST, bundle)
        }
        binding.mChildHomeView.llXuetang.setOnClickListener {
            //已绑定血糖列表
            bundle.clear()
            bundle.putString("userId", showIdInfo)
            RouteManager.goAct(ARouterUrl.XUETANGYI_BIND_LIST, bundle)
        }
        //体脂秤跳转页面
        binding.mChildHomeView.llBodyFat.setOnClickListener {
            bundle.clear()
            bundle.putString("userId", showIdInfo)
            RouteManager.goAct(ARouterUrl.BODY_FAT_BIND_LIST, bundle)
        }
    }*/

    // 刷新注册
    private fun refresh() {
        refresh.setRefresh(binding.mRefresh) {
            request()
        }
    }

    private fun request() {
        mViewModel.getBanners(CommonUtils.getMyUserId())//当期登录用户id

        mViewModel.getAllInfo(showIdInfo, false)
  //      mViewModel.getDkInfo(false, showIdInfo)
        // 如果显示的是家人Tab则不刷新用户信息，防止头像错乱
        if (mFamilyAdapter.position < 1) {
            mViewModel.getMySetting()
        }
        mViewModel.getMyFamilyList()
     /*   mViewModel.getTips()
        mViewModel.getRank(2)*/

        mViewModel.getScinceList()
    }


    //蓝牙连接状态之后 数据上传
    private fun getConnectStatus() {
        LogUtils.d("getConnectStatus!")
        if (YCBBlueConnectHelper.getBlueStatus(false)) {
            LogUtils.d("start get DeviceInfo!")

            //连接之后 直接进行数据的同步
            YCBManager.getDeviceInfo { isok, value ->
                mainScope.launch {
                    LogUtils.d("getDeviceInfo isOk:$isok;;; value=$value")
                    if (isok) {//获取到设备信息，设备准备就绪上传手表数据
//                        binding.mCom.visibility = View.GONE
//                        binding.mEle.visibility = View.VISIBLE
//                        binding.mEle.text = value
                        /*setDeviceInfo(
                            DeviceInfoBean(
                                true,
                                YCBBlueConnectHelper.BLEConnectState.Connected,
                                value
                            )
                        )*/

                        mViewModel.settingLive.value?.let {
                            MyWorkManger.setMyWork(
                                MyApp.instance!!,
                                it.data.user.bluetooth
                            )  //开启后台定时上传任务
                        }

                    } else {//如果获取手表信息失败，断开连接以后让用户手动连接
                        YCBBlueConnectHelper.disconnect()
//                        initBlueToothStatu()
                    }
                }
            }
        } else {
            //断开连接重置状态 为了重新连接自后可以进行睡眠上传
//            initBlueToothStatu()
        }
    }

    private fun blueTooth(): Boolean {

//        CommonUtils.getBlueToothMac()?.let {
//            if (!it.isNullOrEmpty()) {
//                return true
//            }
//        }
        return CommonUtils.isBlueTooth(MMkvHelper.getInt(Const.Watch_Device_Type))
    }


/**
     * 是否绑定了设备*/


    private fun isBind(): Boolean {
//        Const.mainLiveData?.value?.let {
//            if (!it.user.bluetooth.isNullOrEmpty()) {
//                return true
//            }
//        }
//        return false
        return true
    }

  /*  private fun setTips(datas: List<String>) {
//        val datas: List<String> = listOf(
//            "《赋得古原草送别》",
//            "离离原上草，一岁一枯荣。",
//            "野火烧不尽，春风吹又生。",
//            "远芳侵古道，晴翠接荒城。",
//            "又送王孙去，萋萋满别情。"
//        )
        val marqueeFactory: SimpleMF<String?> = SimpleMF(context)
        marqueeFactory.data = datas
        binding.mCom.simpleMarqueeView.setMarqueeFactory(marqueeFactory)
        binding.mCom.simpleMarqueeView.setDrawable(
            getDrawable(R.mipmap.ic_tips_new),
            null,
            null,
            null
        )
        if (binding.mCom.simpleMarqueeView.isFlipping) {
            binding.mCom.simpleMarqueeView.stopFlipping()
        }
//        binding.mCom.simpleMarqueeView.flipInterval = 3 * 1000//轮播间隔时间
        binding.mCom.simpleMarqueeView.startFlipping()
    }*/

   /* private fun updateBadgeNum(num: Int) {
        if (num > 0) {
            var badgeText = if (num > 99) "99+" else "$num"
            binding.mBadge.text = badgeText
            binding.mBadge.post {
                val layoutParams = binding.mBadge.layoutParams as ViewGroup.LayoutParams
                val text = binding.mBadge.text.toString()
                binding.mBadgeCard.radius = binding.mBadge.height / 2f
                var textWidth = binding.mBadge.paint.measureText(text)
                if (binding.mBadge.height >= textWidth) {   //等宽高的圆形
                    layoutParams.width = binding.mBadge.height

                } else {  //宽高不等 将宽度两边加10
                    layoutParams.width = textWidth.toInt() + 20
                }
                binding.mBadge.layoutParams = layoutParams
            }
            binding.mBadgeCard.visibility = View.VISIBLE
        } else {
            binding.mBadgeCard.visibility = View.GONE
        }
    }*/

    override fun onResume() {
        super.onResume()
        mViewModel.getWarningMsg()
    }

    override fun observer() {
        //预警消息
        mViewModel.warningMsgLive.observe(this) {
           /* updateBadgeNum(it.data.noReadNum)
            val systemMessage = it.data.systemMessage
            if (systemMessage != null && systemMessage.isNotEmpty()) {
                val sysMsg = systemMessage[0]
                updateWarningInfo(sysMsg)
            } else {
                updateWarningInfo(null)
            }*/
        }

        //首页轮播图
        mViewModel.bannerLive.observe(this) {
            if (null == it) {
                return@observe
            }

            mBannerAdapter.setDatas(it.data)
            mBannerAdapter.notifyDataSetChanged()
        }

        mViewModel.scinceLive.observe(this) {
            adapterSince.setNewInstance(it.data)
        }

        //手表信息组装上传
        mViewModel.allDataInfo.observe(this) {

            if (null == it || it["data"] == null || it["data"] !is ArrayList<*>) {
                LogUtils.d("手表数据：暂时无数据...")
                getXtInfo(showIdInfo)//如果手表没数据也需要获取获取血糖信息
                get24HourReportInfo(showIdInfo)//如果手表没数据也需要获取24小时日报
                return@observe
            }

            LogUtils.d("手表数据：全部信息开始上传...")
            //是否为错误数据
            var existError = false

            val lists = it["data"] as ArrayList<Any>
            var array = JSONArray()
            lists.forEach { bean ->

                var json = JSONObject()
                var nowData = bean as java.util.HashMap<String, *>
                val iterator = nowData.iterator()
                while (iterator.hasNext()) {
                    val next = iterator.next()
                    var values = if (next.value is Long) (next.value as Long) / 1000 else next.value
                    when (next.key) {
                        "OOValue" -> json.put("ooValue", values)

                        "DBPValue" -> {
                            var sbp = nowData["SBPValue"] as Int
                            var dbp = nowData["DBPValue"] as Int
                            //医学上是大值  收缩压
                            //小值
                            json.put("sbpValue", min(sbp, dbp))
                        }

                        "SBPValue" -> {
                            //医学上是小值  舒张压
                            //大值
                            var sbp = nowData["SBPValue"] as Int
                            var dbp = nowData["DBPValue"] as Int
                            json.put("dbpValue", max(sbp, dbp))
                        }

                        else -> json.put(next.key, values)
                    }
                }
                if (json.has("startTime")) {
                    var times = json.get("startTime").toString().toLong()

                    if (times < 0 || times > System.currentTimeMillis() / 1000) { //错误数据 不使用
                        existError = true
                    } else {
                        array.put(json)
                    }
                }
            }
            //错误数据保存到本地日志
            if (existError) {
                //  saveFile(it.toString()) //存到本地日志
            }

            LogUtils.d("手表数据：array Length:${array.length()}")
            if (array.length() > 0) {
//                var lastJson = array[array.length() - 1] as JSONObject
//                lastJson.put("original", it.toString())
                mViewModel.uploadAllInfo(array)

            }

        }

        //手表数据上传
        mViewModel.uploadMultiple.observe(this) {
            CommonToastUtils.showSucceedToast(R.string.upload_data_success)
            LogUtils.d("all data upload success ")
            get24HourReportInfo(showIdInfo)//数据上传成功后获取24小时日报
            getXtInfo(showIdInfo)//数据上传成功后获取血糖信息
            YCBManager.deleteHistory(YCBOrder.DELETE_ALL) //删除 数据
            mainScope.launch {
                delay(500)
                mViewModel.getAllInfo(showIdInfo, false)
            }
        }
        //睡眠上传
        mViewModel.uploadSleep.observe(this) {
            //睡眠上传成功  清除睡眠数据
            LogUtils.d("sleep upload success ")
            YCBManager.deleteHistory(YCBOrder.SLEEP_HISTORY)
            //clearSleep()
        }

        //步数上传
        mViewModel.uploadStep.observe(this) {
            //步数上传成功
            //YCBManager.deleteHistory(YCBOrder.STEP_HISTORY)
            LogUtils.d("step upload success ")
            mViewModel.getDkInfo(false, showIdInfo)
        }

        //小贴士
        mViewModel.tipsLive.observe(this) {
            LogUtils.d("TipsData:${it.data.size}")
            var list = mutableListOf<String>()
            it.data.forEach { tipsBean ->
                list.add("${tipsBean.title}${tipsBean.content}")
            }
        //    setTips(list)
        }

        //步数信息
 /*       mViewModel.dkInfo.observe(this) {
            mHealthAdapter.dkBean = it.data
            mHealthAdapter.notifyDataSetChanged()
        }*/

        //排名信息
/*        mViewModel.rankLive.observe(this) {
            val content = getString(
                R.string.rank_num,
                if (it.data.userRank == 0) "-" else "${it.data.userRank}"
            )
            binding.mChildHomeView.tvBdContent.text = setStrSpan(
                content,
                15,
                getColor(R.color.col_25C),
                Typeface.BOLD,
                content.length - 1 - (it.data.userRank).toString().length,
                content.length - 1
            )

        }*/

        //个人设置信息获取
        mViewModel.settingLive.observe(this) {
            if (null == it.data) return@observe
            it.data.let { settingBean ->

                if (BuildConfig.isRelease) {//设置极光推送别名
                    JPushInterface.setAlias(
                        requireContext(),
                        settingBean.user.id.toInt(),
                        "user_release_${settingBean.user.id}"
                    )
                }


                Const.mainLiveData.value = settingBean
                mViewModel.getWelcomeInfo(settingBean.user.id)
                mViewModel.getWarningMsg()//获取预警消息

                requestByDeviceModel()
                // 激活过才能开启定是我任务
                //Log.e("worker", "定时任务开启")

                if (!mFamilyAdapter.data.isNullOrEmpty() && mFamilyAdapter.data.size > 0) {
                    mFamilyAdapter.data[0].avatarUrl =
                        if (settingBean.user.avatarUrl.isNullOrEmpty()) "" else settingBean.user.avatarUrl
                }

                //设置用户头像
      /*          setUserImage(
                    settingBean.user.id,
                    settingBean.user.avatarUrl,
                    settingBean.user.sex.toString()
                )*/

                /*if (settingBean.user.bluetooth.isNullOrEmpty()) {  //没有mac地址表示未绑定
//                    binding.mContent.visibility = View.VISIBLE
                    binding.mCom.mLayoutResult.visibility = View.GONE
                    binding.mCom.mBtnBind.visibility = View.VISIBLE
                    setDeviceInfo(DeviceInfoBean(false))
//                    if (!(activity as MainActivity).isDialogShow) {
//                        dialogBind.show()
//                    }
                } else {
                    MyRetrofit.get().BLUETOOTH_MAC = settingBean.user.bluetooth
                    binding.mCom.mLayoutResult.visibility = View.VISIBLE
                    binding.mCom.mBtnBind.visibility = View.GONE
                    //重新签名提示
                    var signTime = settingBean.user.esignatureDate
                    if (!signTime.isNullOrEmpty()) {
                        var againTime = RxTimeTool.string2Milliseconds("2022-07-01 21:00:00")
                        var signTime = RxTimeTool.string2Milliseconds(signTime)
                        if (signTime < againTime) {
                            signDialog.show()
                        }
                    }
                    if (CommonUtils.isBlueTooth(MMkvHelper.getInt(Const.Watch_Device_Type))) {//如果是蓝牙设备
                        startGetDeviceInfoLive()
                        if (settingBean.user.bluetooth != MMkvHelper.getString(Const.Blue_Tooth)) {//如果不是同一设备
                            YCBBlueConnectHelper.disconnect()//断开蓝牙，断开后收到BlueToothConnectEvent会自动连接
                            YCBBlueConnectHelper.cancelTimer()
                        } else {
                            LogUtils.d("startConnect::${settingBean.user.bluetooth}")
                            mainUIUpdate(YCBBlueConnectHelper.BLEConnectState.Connecting)//刷新蓝牙连接状态
                            connect(settingBean.user.bluetooth)
                        }
                    }
                }*/

            /*    if (Const.Companion.WatchDevice.LightA3.ordinal == Const.watchType) {//如果是4G设备，设置连接状态与电量信息
                    setDeviceInfo(
                        DeviceInfoBean(
                            true,
                            YCBBlueConnectHelper.BLEConnectState.Connected,
                            if (Const.battery.isNullOrEmpty()) "" else "电量${Const.battery}%"
                        )
                    )
                    get24HourReportInfo(showIdInfo)// 这里调用一次接口，防止首次进入App不会刷新评估状态
                }*/

                MMkvHelper.put(Const.Blue_Tooth, settingBean.user.bluetooth)
                if (!settingBean.user.deviceId.isNullOrEmpty()) {
                    Const.DeviceIdNum = settingBean.user.deviceId
                } else {
                    Const.DeviceIdNum = ""
                }
//                MMkvHelper.saveAccountConfig(requireContext(),settingBean.user.phone,Const.DEVICE_TYPE, settingBean.user.deviceId)
            }
            //个人信息拿到之后再去获取mqtt信息
            mViewModel.getMqttInfo()

        }

        //血糖信息获取
        mViewModel.xtInfo.observe(this) {
            updateBloodSugarInfo(it.data)
        }

        //获取首页所有信息返回
        mViewModel.allData.observe(this) {
            it.data.let { bean ->

                if (null == bean) {
                    LogUtils.e("没得数据，不做任何处理！")
                    return@observe
                }

                if (bean.user.name.isNullOrEmpty() || bean.user.age.isNullOrEmpty() || bean.user.age == "0") {
                    dialogInfoUn.show()
                }
                isDemonstrate = bean.demonstrate == 1 //1 演示模式，0 普通模式
                (requireActivity() as MainActivity).isDemonstrate = isDemonstrate
           /*     if (isDemonstrate) {
                    binding.mCom.mWearInfo.visibility = View.INVISIBLE
                    binding.mCom.mWatchType.visibility = View.INVISIBLE
                } else {
                    binding.mCom.mWatchType.visibility = View.VISIBLE
                    binding.mCom.mWearInfo.visibility = View.VISIBLE
                }*/
                if (mFamilyAdapter.position != -1) {
                    if (mFamilyAdapter.getItem(mFamilyAdapter.position).userJointId != bean.user.id.toInt()) {
                        if (mFamilyAdapter.position == 0 && bean.user?.id.toString() == CommonUtils.getMyUserId()) {//如果是自己加载用户头像并保存用户信息
                        } else {
                            LogUtils.e("当前用户与请求用户信息不一致，不作处理！")
                            return@observe
                        }
                    }
                }

               /* if (showIdInfo.isEmpty()) {  //自己
//                     binding.mChildHomeView.mGuide2.visibility = View.VISIBLE
                    binding.mChildHomeView.mInter.visibility = View.VISIBLE
                    binding.mChildHomeView.lleach.visibility = View.VISIBLE
                } else {
//                     binding.mChildHomeView.mGuide2.visibility = View.GONE//隐藏健康管家
                    binding.mChildHomeView.mInter.visibility = View.GONE//隐藏健康互动标题
                    binding.mChildHomeView.lleach.visibility = View.GONE//隐藏健康打卡，榜单，我的家人功能
                    Const.otherLiveData.value = bean
                }*/
//                setWeatherInfo(bean.weather)
                Const.battery = bean.power
                Const.watchType = bean.watchType

                //设置健康物联手表是否绑定
               /* if (bean.deviceType.isNullOrEmpty()) {
                    binding.mChildHomeView.tvWatchBind.setTextColor(
                        ContextCompat.getColor(
                            requireContext(),
                            R.color.col_7c7
                        )
                    )
                    binding.mChildHomeView.tvWatchBind.text = "未绑定手表"
                } else {
                    binding.mChildHomeView.tvWatchBind.setTextColor(
                        ContextCompat.getColor(
                            requireContext(),
                            R.color.col_02c
                        )
                    )
                    binding.mChildHomeView.tvWatchBind.text = "已绑定手表"
                }*/
                MMkvHelper.put(Const.Watch_Device_Type, bean.watchType)

                /*if (bean.watchType == -1) {  //没有绑定设备
                    binding.mCom.mBindState.apply {
                        text = "未绑定"
                        val drawable = getDrawable(R.mipmap.ic_unbind)
                        drawable.setBounds(0, 0, drawable.minimumWidth, drawable.minimumHeight)
                        setCompoundDrawables(drawable, null, null, null)
                        visibility = View.VISIBLE
                    }
                    binding.mChildHomeView.mRelInterBD.visibility = View.GONE
                    binding.mCom.mConnectStatu.visibility = View.INVISIBLE
                    binding.mCom.mWatchType.visibility = View.INVISIBLE

                    binding.mCom.mWearManager.text = "绑定手表"

                } else if (Const.Companion.WatchDevice.LightA3.ordinal == bean.watchType) {//如果是4G设备，设置连接状态与电量信息
                    setDeviceInfo(
                        DeviceInfoBean(
                            true,
                            YCBBlueConnectHelper.BLEConnectState.Connected,
                            if (Const.battery.isNullOrEmpty()) "" else "电量${Const.battery}%"
                        )
                    )
                } else {
                    if (showIdInfo.isEmpty()) {  //自己
                        val localBlueMac = MMkvHelper.getString(Const.Blue_Tooth)
                        if (YCBBlueConnectHelper.getBleNowStatus() == YCBBlueConnectHelper.BLEConnectState.DisConnect) {//如果本地有蓝牙信息且属于未连接状态，则直接连接
                            if (localBlueMac.isEmpty()) {
                                mainUIUpdate(YCBBlueConnectHelper.BLEConnectState.DisConnect)//刷新蓝牙连接状态
                            } else {
                                mainUIUpdate(YCBBlueConnectHelper.BLEConnectState.Connecting)//刷新蓝牙连接状态
                                connect(localBlueMac)
                            }
                        } else if (YCBBlueConnectHelper.getBleNowStatus() == YCBBlueConnectHelper.BLEConnectState.Connected) {
                            getConnectStatus()
                        }
                    } else {
                        setDeviceInfo(null)
                    }
                }
                mHealthAdapter.mainBean = bean
                mHealthAdapter.notifyDataSetChanged()
                //总佩戴 活跃 休眠
                binding.mCom.mWearInfo.text = getString(
                    R.string.wear_info,
                    bean.adorn.wearCount.toString(),
                    bean.adorn.activeWear.toString(),
                    bean.adorn.dormancy.toString()
                )
                setBindDeviceInfo(bean.deviceTotal)*/
            }
        }

        //我家人信息
        mViewModel.familyLive.observe(this) {
            it.data.add(0, FamilyBean().apply {
                this.fCall = "我"
            })
            var selectPosition = 0
            if (showIdInfo.isNotEmpty()) {
                it.data.forEachIndexed { index, familyBean ->
                    if (showIdInfo == familyBean.userJointId.toString()) {
                        selectPosition = index
                        return@forEachIndexed
                    }
                }
                //如果家人解绑了 则直接查自己的
                if (selectPosition == 0) {
                    showIdInfo = ""
                }
            }

            val content =
                getString(R.string.family_num, "" + "${it.data.size - 1}")
      /*      binding.mChildHomeView.tvFamilyContent.text = setStrSpan(
                content,
                15,
                getColor(R.color.col_25C),
                Typeface.BOLD,
                content.length - 3 - (it.data.size - 1).toString().length,
                content.length - 3
            )*/
            it.data.add(FamilyBean().apply {
                this.fCall = "家人"
            })
            mFamilyAdapter.position = selectPosition
            mFamilyAdapter.setNewInstance(it.data)
        }

        //15秒钟更新一次蓝牙设备信息
        getDeviceInfoLive.observe(this) {
            LogUtils.d("定时更新一次蓝牙设备信息：${RxTimeTool.curTimeString}")
            startGetDeviceInfoLive()

            if (!MMkvHelper.contains(Const.Watch_Device_Type)) {//没有手表型号
                LogUtils.d("没有获取到手表型号")
                return@observe
            }

            if (!CommonUtils.isBlueTooth(MMkvHelper.getInt(Const.Watch_Device_Type))) {//不是蓝牙设备
                LogUtils.d("不是蓝牙设备！")
                return@observe
            }

            if (!YCBBlueConnectHelper.getBlueStatus(false)) {//蓝牙未连接
                LogUtils.d("蓝牙设备未连接！")
                return@observe
            }

            if ((!showIdInfo.isNullOrEmpty() && showIdInfo != CommonUtils.getMyUserId())) {//不是当前用户
                LogUtils.d("当前用户与showIdInfo不匹配！")
                return@observe
            }

            LogUtils.d("定时获取一次 DeviceInfo!")
            //连接之后 直接进行数据的同步
            YCBManager.getDeviceInfo { isok, value ->
                mainScope.launch {
                    LogUtils.d("getDeviceInfo isOk:$isok;;; value=$value")
                    if (isok) {//获取到设备信息，设备准备就绪上传手表数据
                /*        setDeviceInfo(
                            DeviceInfoBean(
                                true,
                                YCBBlueConnectHelper.BLEConnectState.Connected,
                                value
                            )
                        )*/
                    }
                }
            }
        }

        //24小时健康报告返回信息
        mViewModel.infoLive.observe(this) {

            if (null == it.data) {
                LogUtils.e("返回数据为空！")
                return@observe
            }

            if (null == it.data.healthy) {
                LogUtils.e("健康信息数据为空！")
                return@observe
            }

            if (mFamilyAdapter.position != -1) {
                if (mFamilyAdapter.getItem(mFamilyAdapter.position).userJointId != it.data.user?.id) {
                    if (mFamilyAdapter.position == 0 && it.data.user?.id.toString() == CommonUtils.getMyUserId()) {//如果是自己，啥也不做

                    } else {
                        LogUtils.e("当前用户与请求用户信息不一致，不作处理！")
                        return@observe
                    }
                }
            }

            reportBean = it.data

            var healthResult = it.data.healthy.result
            updateHealthDesc(healthResult)
            //健康状态
          //  binding.mCom.mHealthStatus.setImageResource(UserInfoDefin.healthIcon[healthResult + 1])
//            if (healthResult == 3) {
//                binding.mCom.mHealthStatus.setCompoundDrawables(null, null, null, null)
//            } else {
//                var drawable = ContextCompat.getDrawable(
//                    requireContext(),
//                    UserInfoDefin.healthIcon[healthResult + 1]
//                )
//                drawable!!.setBounds(0, 0, drawable.minimumWidth, drawable.minimumHeight)
//                binding.mCom.mHealthStatus.setCompoundDrawables(drawable, null, null, null)
//            }
        }
    }

    var notifyStatus: Int? = -1
   /* private fun updateWarningInfo(sysMsg: MessageBean.SysMsg?) {
        if (sysMsg == null || mFamilyAdapter.position > 0) {  //如果不是自己，不显示预警消息
            binding.mCom.llWarning.visibility = View.GONE
            return
        } else if (mFamilyAdapter.position == 0 || mFamilyAdapter.position == -1) {
            binding.mCom.llWarning.visibility = View.VISIBLE
        }
        notifyStatus = sysMsg.notifyStatus
        if (notifyStatus == 0) {
            //未读  显示预警消息
            binding.mCom.llWarning.visibility = View.VISIBLE
        } else {
            //已读 显示预警消息
            binding.mCom.llWarning.visibility = View.GONE
        }
        binding.mCom.tvWarning.isSelected = true
        binding.mCom.tvWarning.text = sysMsg.notifyContent
    }*/

/**
     * 通过设备型号来处理不同业务逻辑*/


    private fun requestByDeviceModel() {
        when (MMkvHelper.getInt(Const.Watch_Device_Type)) {//如果是4GA3设备，则隐藏心电板块
            Const.Companion.WatchDevice.LightA3.ordinal -> {
                getXtInfo(showIdInfo, false)//获取血糖信息
//                get24HourReportInfo(showIdInfo)//获取24小时日报
            }

            else -> {
                if (!YCBBlueConnectHelper.isBlueExits()) {//检查蓝牙设备，如未发现蓝牙设备则获取用户上次的血糖信息和24小时信息
                    LogUtils.d("未发现蓝牙设备...")
                    getXtInfo(showIdInfo)//如果手表没数据也需要获取获取血糖信息
//                    get24HourReportInfo(showIdInfo)//如果手表没数据也需要获取24小时日报
                }
            }
        }
    }

/**
     * 更新血糖模块信息*/


    private fun updateBloodSugarInfo(info: XTangInfoBean) {
        if (null == info) {
            LogUtils.e("血糖模块信息没有，出错了~")
            return
        }

        if (!info.errorMsg.isNullOrEmpty()) {
            CommonToastUtils.showToast(info.errorMsg)
        }
/*
        mHealthAdapter.xtangInfo = info
        mHealthAdapter.notifyDataSetChanged()*/
    }


/**
     * 更新健康状态*/


    private fun updateHealthDesc(healthStatus: Int) {
        canGoto24Healthresult = healthStatus != 0 && healthStatus != -1
      /*  binding.mCom.mDesc.apply {
            text = UserInfoDefin.getHealthArray(requireContext())[healthStatus + 1]
            //todo 数据不足 不允许进入健康管理
            setTextColor(
                ContextCompat.getColor(
                    requireContext(),
                    UserInfoDefin.healthCol[healthStatus + 1]
                )
            )
        }*/

//        text =
//            setStrSpan(content, 13, getColor(com.xty.health.R.color.col_ff7), Typeface.BOLD, content.length - 3 - percent.length, content.length - 3)
    }

/**
     * 家人信息绑定*/


    private fun initFamilyAdapter() {
        binding.mCom.mRecycle.layoutManager =
            LinearLayoutManager(requireContext(), RecyclerView.HORIZONTAL, false)
        binding.mCom.mRecycle.adapter = mFamilyAdapter
        mFamilyAdapter.setOnItemClickListener { adapter, view, position ->
            if (position == mFamilyAdapter.data.size - 1) {
                onEventObject(requireContext(), UmengEventId.Family)
                RouteManager.goAct(ARouterUrl.BIND_FAMILY)
            } else {
                var bean = adapter.getItem(position) as FamilyBean
                showIdInfo = if (bean.id == 0) {
                    showFamily = null
                    ""
                } else {
                    showFamily = bean
                    bean.userJointId.toString()
                }
              /*  binding.mCom.mWearManager.visibility =
                    if (showIdInfo.isNullOrEmpty()) View.VISIBLE else View.GONE*/
               /* setUserImage(
                    if (showIdInfo.isNullOrEmpty()) "0" else showIdInfo,
                    bean.avatarUrl,
                    bean.sex.toString()
                )*/
              //  binding.mCom.mUserName.text = bean.fCall
                mFamilyAdapter.position = position
                mFamilyAdapter.notifyDataSetChanged()
                mViewModel.getAllInfo(showIdInfo, true)
                getXtInfo(showIdInfo)
                mViewModel.getDkInfo(false, showIdInfo)
//                updateWarningStatus()
            }
        }
    }

/**
     * 设置用户头像*/


/*    private fun setUserImage(userId: String, headerImage: String?, sex: String) {
        binding.mCom.mHeaderImage.apply {
            tag = userId
            setImageUser(requireContext(), headerImage, sex)
            setOnClickListener {
                if (tag.toString()
                        .isNullOrEmpty() || tag.toString() == "0" || Const.mainLiveData.value?.user?.id.toString() == userId.toString()
                ) {
                    RouteManager.goAct(ARouterUrl.BASE_INFO_CHANGE, bundle)
                }
            }
        }
    }*/
/*
*
     * 获取所有信息*/


    private fun getAllData() {
        YCBManager.getAllData {
            mainScope.launch {
                mViewModel.allDataInfo.postValue(it)
            }
        }
    }

/**
     *15秒钟之内只能上传一次睡眠数据 避免重复上传*/


    private fun refreshTime() {
        if (isRefresh) {
            isRefresh = false
            mainScope.launch {
                delay(15 * 1000)
                isRefresh = true

            }
        }
    }

/**
     * 获取历史步数*/


    private fun getStep() {
        YCBManager.getHistoryInfo(YCBOrder.STEP_DATA) {
            mainScope.launch {
                LogUtils.d("getStep Info!")
                var jsonArray = JSONArray()
                var arrayOrigin = JSONArray()
                for (i in 0 until it.size) {
                    var info = it[i] as HashMap<String, Any>
                    var jsonOrigin = JSONObject()
                    for ((k, v) in info) {
                        jsonOrigin.put(k, v)
                    }
                    arrayOrigin.put(jsonOrigin)
                    var dataDayStr = RxTimeTool.milliseconds2String(
                        System.currentTimeMillis(),
                        SimpleDateFormat("yyyy-MM-dd")
                    )
                    var todayStartTime =
                        RxTimeTool.string2Milliseconds("$dataDayStr 00:00:00")  //今天0点的时间

                    var startTime = (info["sportStartTime"] as Long)
                    if (startTime < todayStartTime) {
                        continue
                    }


                    var json = JSONObject()
                    json.put("startTime", (info["sportStartTime"] as Long) / 1000)
                    json.put("endTime", (info["sportEndTime"] as Long) / 1000)
                    json.put("step", info["sportStep"])
                    json.put("calories", info["sportCalorie"])
                    json.put("distance", info["sportDistance"])
                    jsonArray.put(json)
                }
                mViewModel.uploadStep(jsonArray)

            }
        }
    }


/**
     * 获取血糖信息*/


    private fun getXtInfo(userId: String, isShowLoading: Boolean = false) {
        mViewModel.getXtInfo(userId, isShowLoading)
    }

/**
     * 获取24小时健康报告*/


    private fun get24HourReportInfo(userId: String, isShowLoading: Boolean = false) {
        mViewModel.get24HourReportInfo(userId, isShowLoading)
    }
/**
     * 新 睡眠时间上传
     * 限制睡眠在一定时间内请求的次数*/


    private fun getSleepNew() {
        YCBManager.getHistoryInfo(YCBOrder.SLEEP_DATA) {
            LogUtils.d("getSleep Info!")
            mainScope.launch {
                if (it.isNullOrEmpty()) {
                    return@launch
                }

                CommonUtils.getMyUserInfo()?.apply {
                    try {
                        var arraySleep = JSONArray()
                        var rawdata = sleepOriganData(it)
                        for (i in 0 until it.size) {
                            var json = JSONObject()
                            var sleepDetailArray = JSONArray() //详细的睡眠时间
                            var lastData = it[i] as HashMap<*, *>
                            var startTime = lastData["startTime"] as Long
                            var endTime = lastData["endTime"] as Long

                            var lightAll = lastData["lightSleepTotal"] as Int  //潜睡时长
                            var deepLightAll = lastData["deepSleepTotal"] as Int  //深睡时长

                            var deepSleepCount = lastData["deepSleepCount"] as Int //深睡次数
                            var lightSleepCount = lastData["lightSleepCount"] as Int //浅睡次数

                            var listSleepData = lastData["sleepData"] as ArrayList<*>

                            listSleepData.forEach {
                                var value = it as HashMap<*, *>
                                var jsonValue = JSONObject()
                                jsonValue.put(
                                    "sleepStartTime",
                                    (value["sleepStartTime"] as Long) / 1000
                                )
                                jsonValue.put("sleepLen", value["sleepLen"] as Int)
                                jsonValue.put("sleepType", value["sleepType"] as Int)
                                jsonValue.put("userId", id)
                                jsonValue.put("createBy", name)
                                sleepDetailArray.put(jsonValue)
                            }

                            json.put("userId", id)
                            json.put("createBy", name)
                            json.put("lightSleepCount", lightSleepCount)  //浅睡次数
                            json.put("deepSleepCount", deepSleepCount)  //深睡次数
                            json.put("hmWatchSleepData", sleepDetailArray)
                            json.put("lightSleepTotal", max(lightAll, deepLightAll))   //潜睡时长
                            json.put("deepSleepTotal", min(lightAll, deepLightAll))  //深睡时长
                            json.put("startTime", startTime / 1000) //开始时间
                            json.put("endTime", endTime / 1000)  //结束时间
                            json.put("os", "android")
                            if (i == it.size - 1) {
                                json.put("original", rawdata.toString())
                            } else {
                                json.put("original", "---")
                            }
                            arraySleep.put(json)
                        }
                        if (arraySleep.length() > 0) {
                            mViewModel.uploadSleep(arraySleep)
                        }
                    } catch (e: Exception) {
                        LogUtils.e("睡眠数据上传错误:$e")
                    }
                }
            }
        }
    }

/**
     *   修改背景色*/


    private fun changeBg(view: View, colId: Int) {
        var bg = view.background as GradientDrawable
        bg.setColor(ContextCompat.getColor(requireContext(), colId))
        bg.mutate()
    }

    private val reqGpsPermissionDialog by lazy {
        NoticeSettingDialog(requireContext(), "请打开GPS权限", {

        }) {
            // 转到手机设置界面，用户设置GPS
            var intent = Intent(Settings.ACTION_LOCATION_SOURCE_SETTINGS);
            startActivityForResult(intent, 1001) // 设置完成后返回到原来的界面
        }
    }


    private fun requestGPSPermission() {
        reqGpsPermissionDialog.show()
    }

/**
     * 蓝牙链接*/


    private fun connect(mac: String) {

        if (!CommonUtils.isBlueTooth(MMkvHelper.getInt(Const.Watch_Device_Type))) {//如果不是蓝牙设备，不进行连接
            return
        }

        if (mac.isNullOrEmpty()) {
//            initBlueToothStatu()
            return
        }

        if (!checkBlueConnectPermission(requireContext())) {
            CommonToastUtils.showToast("请开启App蓝牙搜索权限！")
            getBluePermission(requireContext()) {
                if (it) {
                    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M && !isGpsOpen(requireContext())) {
                        requestGPSPermission()
                    }
                }
            }
            return
        }

        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M && !isGpsOpen(requireContext())) {
            CommonToastUtils.showToast("请打开GPS权限！")
            requestGPSPermission()
            return
        }

        mainScope.launch(Dispatchers.IO) {
            LogUtils.d("HealthFrag Connect!!!")
            YCBBlueConnectHelper.connectionBlueTooth(mac, true) {
                mainUIUpdate(it)
            }
        }
    }

    private fun mainUIUpdate(connectState: YCBBlueConnectHelper.BLEConnectState) {

        mainScope.launch(Dispatchers.Main) {
            when (connectState) {
                YCBBlueConnectHelper.BLEConnectState.Connecting -> {
               /*     setDeviceInfo(
                        DeviceInfoBean(
                            true,
                            YCBBlueConnectHelper.BLEConnectState.Connecting
                        )
                    )*/
//                    binding.mContent.visibility = View.GONE
//                    binding.mEle.visibility = View.VISIBLE
//                    binding.mEle.text = getString(R.string.blue_tooth_connecting)
                }

                YCBBlueConnectHelper.BLEConnectState.Connected -> {
                    getConnectStatus()
                }

                YCBBlueConnectHelper.BLEConnectState.DisConnect -> {
                    //断开连接重置状态 为了重新连接自后可以进行睡眠上传
                   // initBlueToothStatu()
                }
            }
        }
    }


/*    private fun initBlueToothStatu() {
        setDeviceInfo(DeviceInfoBean(blueTooth(), YCBBlueConnectHelper.BLEConnectState.DisConnect))
    }*/

    //workmanager 后台上传任务
    @Subscribe(threadMode = ThreadMode.MAIN)
    fun workManagerSuccess(event: WorkManagerEvent) {
        //上传成功回传刷新
        LogUtils.d("work is ok")
        mViewModel.getAllInfo(showIdInfo, false)
    }

    //个人信息修改 主界面刷新
    @Subscribe(threadMode = ThreadMode.MAIN)
    fun refresh(event: MyInfoEvent) {
        if (dialogBind.isShowing) {
            dialogBind.dismiss()
        }
        request()
    }

    //绑定状态下的蓝牙连接状态
    @Subscribe(threadMode = ThreadMode.MAIN)
    fun blueToothStatus(event: BlueToothConnectEvent) {
        LogUtils.d("blueToothStatus change!!")
        CommonUtils.getBlueToothMac()?.let {
            connect(it)
        }
    }

    //家人信息改变 刷新
    @Subscribe(threadMode = ThreadMode.MAIN)
    fun familyChange(event: FamilyEvent) {
        mViewModel.getMyFamilyList()
    }

/**
     * 重新签名之后隐藏提示框*/


    @Subscribe(threadMode = ThreadMode.MAIN)
    fun againSignEvent(event: AgainSignEvent) {
        signDialog.dismiss()
    }

/**
     * 24小时健康状态更新事件
*/


    @Subscribe(threadMode = ThreadMode.MAIN)
    fun health24HourStatusUpdate(event: Health24HourStatusEvent) {
        if (-2 != event.healthStatus) {
            updateHealthDesc(event.healthStatus)
        }
    }

/**
     * 血糖开通/续费成功*/


    @Subscribe(threadMode = ThreadMode.MAIN)
    fun xtOpenSuccess(event: XTangOpenEvent) {
        var time = RxTimeTool.getCurrentDateTime("mm").toInt()
        var sPrefix = String.format("%02d", time / 10 * 10)  //当前时间对应的整分钟数
        var nowTimeStr = RxTimeTool.getCurrentDateTime("yyyy-MM-dd HH") + ":${sPrefix}" //整点时间
//        updateBloodsugarStatus(event.model, nowTimeStr)
    }

/**
     * 血糖信息更新*/


    @Subscribe(threadMode = ThreadMode.MAIN)
    fun xtDataUpdate(event: XTangUpdateEvent) {
        LogUtils.d("xtDataUpdate!!!")
        updateBloodSugarInfo(event.info)
    }

/**
     * 睡眠的原始数据*/


    private fun sleepOriganData(list: ArrayList<Any>): JSONArray {
        var array = JSONArray()
        list.forEach {
            try {
                var json = JSONObject()
                var lastData = it as HashMap<*, *>

                var startTime = lastData["startTime"] as Long
                var endTIme = lastData["endTime"] as Long

                var l = lastData["lightSleepTotal"] as Int  //潜睡时长
                var d = lastData["deepSleepTotal"] as Int  //深睡时长

                json.put("startTime", startTime)
                json.put("endTime", endTIme)
                json.put("lightSleepTotal", l)
                json.put("deepSleepTotal", d)

                var listSleepData = lastData["sleepData"] as ArrayList<*>
                var sleepArray = JSONArray()
                listSleepData.forEach {
                    var value = it as HashMap<*, *>
                    var jsonValue = JSONObject()
                    jsonValue.put("sleepStartTime", (value["sleepStartTime"] as Long))
                    jsonValue.put("sleepLen", value["sleepLen"] as Int)
                    jsonValue.put("sleepType", value["sleepType"] as Int)
                    sleepArray.put(jsonValue)
                }
                json.put("sleepData", sleepArray)
                array.put(json)
            } catch (e: Exception) {
                e.printStackTrace()
            }
        }
        return array
    }

/**
     * 15秒钟一次更新*/


    private fun startGetDeviceInfoLive() {
        getDeviceInfoJob = mainScope.launch(Dispatchers.IO) {
            delay(1000 * 15)
            LogUtils.d("休眠结束：${RxTimeTool.curTimeString}")
            getDeviceInfoLive.postValue("")
        }
    }

/**
     * 更新血糖状态*/


/*    private fun updateBloodsugarStatus(model: Int, updateTime: String) {
        mHealthAdapter.xtangInfo?.let {
            it.model = model
            it.time = updateTime
        }
        mHealthAdapter.notifyDataSetChanged()
    }*/

    override fun onActivityResult(requestCode: Int, resultCode: Int, data: Intent?) {
        super.onActivityResult(requestCode, resultCode, data)
        if (resultCode == RESULT_OK) {
            when (requestCode) {
                1001 -> {
                    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.M && isGpsOpen(requireContext())) {//如果GPS已打开
                        LogUtils.d("GPS Is Open!")
                        mainScope.launch {
                            CommonUtils.getBlueToothMac()?.let {
                                connect(it)
                            }
                        }
                    }
                }
            }
        }
    }
}
