package com.zj365.dc.fragment

import android.os.Build
import android.text.TextUtils
import android.view.View
import androidx.annotation.RequiresApi
import com.tencent.qcloud.tuicore.event.ShowSystemMessageEvent
import com.xty.base.fragment.BaseVmFrag
import com.xty.common.*
import com.xty.common.arouter.ARouterUrl
import com.xty.common.arouter.RouteManager
import com.xty.common.bracelet.YCBBlueConnectHelper
import com.xty.common.event.MyInfoEvent
import com.xty.common.util.CommonToastUtils
import com.xty.common.util.CommonUtils

import com.xty.network.model.SettingBean
import com.zj365.dc.activity.MainActivity
import com.zj365.dc.databinding.FragMineBinding
import com.zj365.health.weight.DialogTip
import com.zj365.mime.vm.SettingVm
import org.greenrobot.eventbus.EventBus

/**
** 我的
*/


class MineFrag : BaseVmFrag<SettingVm>() {

    private val binding by lazy { FragMineBinding.inflate(layoutInflater) }
    override fun setLayout(): View = binding.root

    private val defaultIcon by lazy {
        arrayOf(
            R.mipmap.ic_default_man,
            R.mipmap.ic_default_women
        )
    }
    var user: SettingBean.User? = null

    private val dialogBind by lazy {
        DialogTip(requireContext(), "需绑定安瑜健康手表，才能查看", "去绑定") {
            RouteManager.goAct(ARouterUrl.DEVICE_CHOICE)
        }
    }

    override fun setViewModel() = SettingVm()

    @RequiresApi(Build.VERSION_CODES.O)
    override fun initView() {
        super.initView()
//        statusBar(binding.mStatusBar)
        binding.mNoNetwork.mRefreshBtn.isSelected = true
        binding.mNoNetwork.mRefreshBtn.setOnClickListener {
            mViewModel.getMySetting()
        }

        binding.mImage.setOnClickListener {
            if(MMkvHelper.getLong(Const.USER_ID).toString() == "0"){
                RouteManager.goAct(ARouterUrl.LOGIN_ACT)
            }else{
                RouteManager.goAct(ARouterUrl.MY_INFO)
            }
        }

        binding.mllIntegral.setOnClickListener {  //积分
            bundle.clear()
            bundle.putSerializable("user", user)
            RouteManager.goAct(ARouterUrl.MY_INTEGRAL, bundle)

             /*   bundle.clear()
             bundle.putString("url","https://blog.csdn.net/wenmang_star/article/details/72911605")
          RouteManager.goAct( ARouterUrl.WEB_ACT)
*/
        }
        binding.llAboutUs.setOnClickListener {
            RouteManager.goAct(ARouterUrl.ABOUT)
        }
 /*       binding.mTvMsg.setOnClickListener {
//            RouteManager.goAct(ARouterUrl.MESSAGE)
            (requireActivity() as MainActivity).setCurrentTab(2)
        }*/
        binding.llSetting.setOnClickListener {
            bundle.clear()
            bundle.putSerializable("user", user)
            bundle.putBoolean("isDemonstrate", (requireActivity() as MainActivity).isDemonstrate)
            RouteManager.goAct(ARouterUrl.SETTING, bundle)
        }
/*        binding.mTvOrgan.setOnClickListener {//我的机构
            bundle.clear()
//            bundle.putSerializable("user", user)
            RouteManager.goAct(ARouterUrl.MY_ORGAN, bundle)
        }*/
        binding.llOrder.setOnClickListener {
            bundle.clear()
            bundle.putString("id", user?.id)
            RouteManager.goAct(ARouterUrl.ORDER_LIST, bundle)
        }
        /*binding.mllmProg.setOnClickListener {
            onEventObject(requireContext(), UmengEventId.HealthProgrammes, "我的页面")
            RouteManager.goAct(ARouterUrl.MY_PROG)
        }*/
        binding.llFamilyHealth.setOnClickListener {
            RouteManager.goAct(ARouterUrl.FAMILY)
        }
        /*binding.mFamily.setOnClickListener {
            RouteManager.goAct(ARouterUrl.FAMILY)
        }*/
       /* binding.mTvAppoint.setOnClickListener {
            if ((requireActivity() as MainActivity).isDemonstrate) {
                dialogBind.show()
                return@setOnClickListener
            }
            RouteManager.goAct(ARouterUrl.MY_APPOINT)
        }*/
   /*     binding.mKeeper.setOnClickListener {
//            if ((requireActivity() as MainActivity).isDemonstrate ){
//                return@setOnClickListener
//            }
            CommonUtils.getMyUserId()?.let {
                bundle.clear()
                bundle.putString("fromUserId", it)
                RouteManager.goAct(ARouterUrl.MY_KEEPER, bundle)
            }
        }*/
        binding.llWearableDevice.setOnClickListener {
            CommonUtils.getMyUserInfo()?.let {
                if (it.watchName == null) {
                    RouteManager.goAct(ARouterUrl.DEVICE_CHOICE)
                } else {
                    //设备信息
                    //   unBindDialog.show()
                    bundle.clear()
                    bundle.putSerializable("user", it)
                    RouteManager.goAct(ARouterUrl.DEV_INFO, bundle)
                }
            }
        }
        /*binding.mSign.setOnClickListener {
            if ((requireActivity() as MainActivity).isDemonstrate) {
                RouteManager.goAct(ARouterUrl.BASE_INFO_CHANGE, bundle)
                return@setOnClickListener
            }
            user?.let {
                if (it.sign == 0) {
                    mViewModel.sign()
                }
            }
        }*/
        binding.mInfo.setOnClickListener {
            RouteManager.goAct(ARouterUrl.BASE_INFO_CHANGE, bundle)
        }
       /* //邀请记录
        binding.tvLnvitationMessage.setOnClickListener {
            bundle.clear()
            bundle.putSerializable("user", user)
            RouteManager.goAct(ARouterUrl.LNVITATION_MESSAGE, bundle)
        }
        //邀请好友
        binding.llInviteFriends.setOnClickListener {
            bundle.clear()
            bundle.putSerializable("user", user)
            RouteManager.goAct(ARouterUrl.INVITE_FRIENDS, bundle)
        }*/
        mViewModel.getNesProg("")
    }

    override fun onResume() {
        super.onResume()
        if (!checkNetworkAvailable(requireContext())) {
            binding.mNoNetwork.root.visibility = View.VISIBLE
        } else {
            if (binding.mNoNetwork.root.visibility == View.VISIBLE) {
                mViewModel.getMySetting()
            }
            mViewModel.getScore(1)
            mViewModel.getMyFamilyList()
            mViewModel.getNesProg("")
            mViewModel.getInviteCountRequest(CommonUtils.getMyUserId().toString())
//            mViewModel.getNotReadCount()
        }
    }

    override fun observer() {
       /* mViewModel.familyLive.observe(this) {
            binding.mFamily.text = it.data.size.toString()
        }*/
        mViewModel.progLive.observe(this) {
            binding.mProg.text = it.data.size.toString()
        }
        mViewModel.scoreLive.observe(this) {
            binding.mTvSource.text = (if (it.data.num.isNullOrEmpty()) "0" else it.data.num!!)
        }
        //设置邀请人数
        mViewModel.inviteCountLive.observe(this) {
            binding.tvInviteCount.text = if (!TextUtils.isEmpty(it.data)) {
                it.data
            } else {
                "0"
            }
        }

        Const.mainLiveData.observe(this) {
            if (null == it) {
                return@observe
            }
            user = it.user
            binding.mName.text = it.user.name
            binding.mPhone.text = "账户：${it.user.phone}"
//            binding.mDk.text = it.clock.toString()
//            binding.mLevel.text = it.grade
            if (it.user.avatarUrl.isNullOrEmpty()) {
                binding.mImage.setImageResource(defaultIcon[if (it.user.sex - 1 < 0) 0 else it.user.sex - 1])
            } else {
                binding.mImage.setImageUser(
                    requireContext(),
                    it.user.avatarUrl,
                    it.user.sex.toString()
                )
                Const.CHAT_IMAGE = it.user.avatarUrl
            }

         /*   if (it.user.sign == 0) {
                binding.mSign.text = "签到"
            } else {
                binding.mSign.text = "已签到"
            }*/
        }

        mViewModel.unbindLive.observe(this) {
            user!!.bluetooth = ""
            YCBBlueConnectHelper.disconnect()
            YCBBlueConnectHelper.cancelTimer()
            EventBus.getDefault().post(MyInfoEvent())  //刷新个人信息
        }
       /* mViewModel.signLive.observe(this) {
            CommonToastUtils.showSucceedToast("签到成功")
            binding.mSign.text = "已签到"
            user!!.sign = 1
        }*/
        mViewModel.countLive.observe(this) {
//            setBadge(it.data.count)
            (requireActivity() as MainActivity).setUnreadcount(it.data.count)
            EventBus.getDefault()
                .post(ShowSystemMessageEvent(it.data.msg, it.data.time, it.data.count))
        }
        //个人设置信息获取
        mViewModel.settingLive.observe(this) {
            if (null == it.data) return@observe
            it.data.let { settingBean ->
                Const.mainLiveData.value = settingBean
                binding.mNoNetwork.root.visibility = View.GONE
            }
        }


    }


/*** 设置消息数量*/


    private fun setBadge(num: Int) {
//        if (num > 0) {
//            binding.mCard.visibility = View.VISIBLE
//            binding.mBadge.text = if (num > 99) "99+" else "$num"
//            binding.mBadge.post {
//                val layoutParams = binding.mBadge.layoutParams as ViewGroup.LayoutParams
//                val text = binding.mBadge.text.toString()
//                binding.mCard.radius = binding.mBadge.height / 2f
//                var textWidth = binding.mBadge.paint.measureText(text)
//                if (binding.mBadge.height >= textWidth) {   //等宽高的圆形
//                    layoutParams.width = binding.mBadge.height
//
//                } else {  //宽高不等 将宽度两边加10
//                    layoutParams.width = textWidth.toInt() + 20
//                }
//                binding.mBadge.layoutParams = layoutParams
//            }
//        } else {
//            binding.mCard.visibility = View.GONE
//        }
    }

}
